/*=============================================================================





=============================================================================*/

#include <tmodel.h>

#ifndef M_PI
#define M_PI              3.14159265358979323846
#endif

/* 
                          EXTERNAL
*/

extern void plmbar        
(
   double *p,
   double *dp,
   double *costh,
   int    *degree,
   int    *inorm
);

extern void magfdz        
(
   double *p,
   double *dp,
   double *theta,
   double *phi,
   double *rad,
   int    *degree,
   double *g,
   double *dx,
   double *dy,
   double *dz,
   double *dpot,
   double *x,
   double *y,
   double *z,
   double *h,
   double *f,
   double *ainc,
   double *d,
   double *pot
);

extern void magfdz_ext    
(
   double *p,
   double *dp,
   double *theta,
   double *phi,
   double *rad,
   int    *degree,
   double *g,
   double *dx,
   double *dy,
   double *dz,
   double *dpot,
   double *x,
   double *y,
   double *z,
   double *h,
   double *f,
   double *ainc,
   double *d,
   double *pot
);

extern int sm2geo_init
(
   char           sm2geo_fname[],
   int            *deg_ext,
   int            *deg_day,
   int            maxcoeff,
   double         coeff[SM2GEO_MAXNCOEFF]
);

extern int sm2geo
(
   double         fday,
   int            deg_wanted,   
   int            deg_ext,
   int            deg_day,
   double         coeff[SM2GEO_MAXNCOEFF],  
   double         smcoeff[MAX_EXT_NCOEFF],
   double         geocoeff[MAX_EXT_NCOEFF]
);

extern int sm2geo_green
(
   double         fday,
   int            deg_want,        
   int            deg_ext,
   int            deg_day,
   double         coeff[SM2GEO_MAXNCOEFF], 
   tgsm2geo_green green_day_r,
   tgsm2geo_green green_day_i
);

extern int gsm2geo_init
(
   char           gsm2geo_fname[],
   int            *deg_ext,
   int            *deg_day,
   int            *deg_ann,
   int            maxcoeff,
   double         coeff[GSM2GEO_MAXNCOEFF]
);

extern int gsm2geo
(
   double         fday,
   int            deg_wanted, 
   int            deg_ext,   
   int            deg_day,
   int            deg_ann,
   double         coeff[GSM2GEO_MAXNCOEFF], 
   double         gsmcoeff[MAX_EXT_NCOEFF],
   double         geocoeff[MAX_EXT_NCOEFF]
);

extern int gsm2geo_green
(
   double         fday,
   int            deg_want, 
   int            deg_ext,
   int            deg_day,
   int            deg_ann,
   double         coeff[SM2GEO_MAXNCOEFF],
   tgsm2geo_green green_day_r,
   tgsm2geo_green green_day_i,
   tgsm2geo_green green_ann_r,
   tgsm2geo_green green_ann_i
);

#ifndef POMME3D1

extern int pomme_control            
(
   tmodel *model,
   char   *action
);

extern int pomme_open_file_mp      
(
   char   *mainfname, 
   char   *sm2geocf,
   char   *gsm2geocf,
   tmodel *model,
   long   model_nbytes,
   int    debug
);

extern int pomme_internal_field_mp 
(
   tmodel *model,
   double fday, 
   double rad, 
   double theta, 
   double phi, 
   double *x, 
   double *y,
   double *z, 
   double *f
);

extern int pomme_external_field_mp 
(
   tmodel *model,
   double fday, 
   double rad, 
   double theta, 
   double phi, 
   double est, 
   double ist,
   double imfby, 
   double *x, 
   double *y, 
   double *z
);

extern int pomme_field_mp
(
   tmodel *model,
   double fday, 
   double r, 
   double theta, 
   double phi,
   double est, 
   double ist, 
   double imf_by,
   double *x, 
   double *y, 
   double *z, 
   double *f
);

#endif

/*=============================================================================
   EOF pomme3d1.h
=============================================================================*/
