/*=============================================================================

   POMME: POtsdam Magnetic Model of the Earth
   -------==------=--------=------------=----
   Version 2.3

   2004-Oct, Stefan Maus, NOAA.

=============================================================================*/

#define SQRT2                1.0   /* sqrt(2.0) normalization taken out */

#define WD                   (2.0 * M_PI)
#define WA                   (2.0 * M_PI / 365.25)

#define MAX_S_COEFF          15      /* spatial coefficients */
#define MAX_T_COEFF          13      /* temporal coefficients */
#define MAXPERIOD            7       /* const, 24h, 12h, 8h ..., */


typedef double               tgsm2geo_green[MAX_S_COEFF]
                                           [MAX_S_COEFF]
                                           [MAXPERIOD];

typedef double               tsm2geo_green [MAX_S_COEFF]
                                           [MAX_S_COEFF]
                                           [MAXPERIOD];

#define SM2GEO_MAXNCOEFF    (MAX_S_COEFF * MAX_S_COEFF * \
                             MAX_T_COEFF                 )
#define GSM2GEO_MAXNCOEFF   (MAX_S_COEFF * MAX_S_COEFF * \
                             MAX_T_COEFF * MAX_T_COEFF   )


typedef double tgsm2geo_coeff[GSM2GEO_MAXNCOEFF];
typedef double tsm2geo_coeff [SM2GEO_MAXNCOEFF];

/*
------- x2geo.h -------
*/
