      subroutine magfdz(p,dp,theta,phi,r,lmax,g,dx,dy,dz,
     >                  dpot,x,y,z,h,f,i,d,pot)

      implicit real*8 (a-h,o-z)

c
c***************************************************************
c
c     j bloxham  8 nov 1982 & 11 oct 1983
c
c     modified version of dg13.sv.fort:magfd & jb62.sv.progs:magfds
c
c     gives field components at radius r
c
c     if igeo=1 then the field elements are rotated to
c     the local geodetic frame at the point specified by
c     (r,theta,phi) in the spherical coordinate system.
c
c***************************************************************
c
c
c     this version 16 jan 87
c
c     saves dx dy dz in computation
c
c
c  stefan: 
c   modified to do the potential and thrown out igeo stuff
c
cc======================================================================

      dimension g(lmax*(lmax+2))
      dimension dx(lmax*(lmax+2)),dy(lmax*(lmax+2)),dz(lmax*(lmax+2))
      dimension dpot(lmax*(lmax+2))
      dimension p((lmax+1)*(lmax+2)/2),dp((lmax+1)*(lmax+2)/2)
      real*8 i

      b=6371.2/r
      x=0.
      y=0.
      z=0.
      pot = 0.
      sinth=sin(theta)
      if(abs(sinth).lt.1.e-10) sinth=1.e-10

c     write(6,*) '0: theta = ', theta, ' sin(theta) = ',sinth

      do 20 l=1,lmax

      l1=l+1
      bb=b**(l+2)

c     write(6,*) '---- i b = ', l+2, b

      k=l*l
      k1=(l*l1)/2+1

c     write(6,*) '---- k k1 g[k] dp[k1] p[k1] bb = ', 
c    .     k, k1, g(k), dp(k1), p(k1), bb

      dx(k)=dp(k1)*bb
      dy(k)=0.
      dz(k)=-p(k1)*l1*bb

c     write(6,*) '----      dx(k) dy(k) dz(k) = ',dx(k),dy(k),dz(k)
c     write(6,*)

      dpot(k)=p(k1)*r*bb
      x=x+g(k)*dx(k)
      z=z+g(k)*dz(k)
      pot=pot+g(k)*dpot(k)

c     write(6,*) '1: x,y,z, k, pot, dpot(k) = ', x, y, z, k,pot,dpot(k)

      do 20 m=1,l

      t=float(m)*phi
      k=l*l+2*m-1
      k1=(l*l1)/2+m+1
      sint=sin(t)
      cost=cos(t)

      dxd = dp(k1)*bb
      dx(k) = dxd*cost
      dx(k+1) = dxd*sint
      x = x + (g(k)*dx(k)) + (g(k+1)*dx(k+1))

      dxy = m*p(k1)*bb/sinth
      dy(k) = dxy*sint
      dy(k+1) = -dxy*cost
      y = y + (g(k)*dy(k)) + (g(k+1)*dy(k+1))

      dzd = -l1*p(k1)*bb
      dz(k) = dzd*cost
      dz(k+1) = dzd*sint
      z = z + (g(k)*dz(k)) + (g(k+1)*dz(k+1))

      dpotd = r*p(k1)*bb
      dpot(k) = dpotd*cost
      dpot(k+1) = dpotd*sint
      pot = pot + (g(k)*dpot(k)) + (g(k+1)*dpot(k+1))

c     write(6,*) '------ 2: x,y,z = ', x, y, z

20    continue
      

      h=sqrt(x*x+y*y)
      f=sqrt(h*h+z*z)
      i=asin(z/f)
      d=atan2(y,x)

      return
      end
       
      subroutine magfdz_ext(p,dp,theta,phi,r,lmax,g,dx,dy,dz,
     >                      dpot,x,y,z,h,f,i,d,pot)
      implicit real*8 (a-h,o-z)

c
c***************************************************************
c
c     same thing for external field....
c
c     j bloxham  8 nov 1982 & 11 oct 1983
c
c     modified version of dg13.sv.fort:magfd & jb62.sv.progs:magfds
c
c     gives field components at radius r
c
c     if igeo=1 then the field elements are rotated to
c     the local geodetic frame at the point specified by
c     (r,theta,phi) in the spherical coordinate system.
c
c***************************************************************
c
c
c     this version 16 jan 87
c
c     saves dx dy dz in computation
c
c
c  stefan: 
c   modified to do the potential and thrown out igeo stuff
c
cc======================================================================


      dimension g(lmax*(lmax+2))
      dimension dx(lmax*(lmax+2)),dy(lmax*(lmax+2)),dz(lmax*(lmax+2))
      dimension dpot(lmax*(lmax+2))
      dimension p((lmax+1)*(lmax+2)/2),dp((lmax+1)*(lmax+2)/2)
      real*8 i


      b=6371.2/r
      x=0.
      y=0.
      z=0.
      pot = 0.
      sinth=sin(theta)
      if(abs(sinth).lt.1.e-10) sinth=1.e-10

      do 20 l=1,lmax

      l1=l+1
      bb=b**(-l+1)
      k=l*l
      k1=(l*l1)/2+1

      dx(k)=dp(k1)*bb
      dy(k)=0.
      dz(k)=l*p(k1)*bb
         dpot(k)=p(k1)*r*bb
      x=x+g(k)*dx(k)
      z=z+g(k)*dz(k)
         pot=pot+g(k)*dpot(k)

      do 20 m=1,l

      t=float(m)*phi
      k=l*l+2*m-1
      k1=(l*l1)/2+m+1
      sint=sin(t)
      cost=cos(t)

      dxd = dp(k1)*bb
      dx(k) = dxd*cost
      dx(k+1) = dxd*sint
      x = x + (g(k)*dx(k)) + (g(k+1)*dx(k+1))

      dxy = m*p(k1)*bb/sinth
      dy(k) = dxy*sint
      dy(k+1) = -dxy*cost
      y = y + (g(k)*dy(k)) + (g(k+1)*dy(k+1))

      dzd = l*p(k1)*bb
      dz(k) = dzd*cost
      dz(k+1) = dzd*sint
      z = z + (g(k)*dz(k)) + (g(k+1)*dz(k+1))

      dpotd = r*p(k1)*bb
      dpot(k) = dpotd*cost
      dpot(k+1) = dpotd*sint
      pot = pot + (g(k)*dpot(k)) + (g(k+1)*dpot(k+1))

c     write(6,*) 'x,y,z = ', x, y, z

20    continue
      

      h=sqrt(x*x+y*y)
      f=sqrt(h*h+z*z)
      i=asin(z/f)
      d=atan2(y,x)

      return
      end
