
FUNCTION pomme_kill, model, lib = lib
;+=============================================================================
;
;  IDL wrapper for POMME2 code of Stefan Maus.
;
;  Input:
;
;  Keywords:
;
;                 lib            string with path/file of pomme library to use
;
;  Returns:
;
;                 long           a pointer to model structure (hidden),
;                                used in 'pomme_calc' and 'pomme_control'.
;
;  2004-Nov-11. Martin Rother (rother@gfz-potsdam.de).
;  2006-Jan-27. simplified with system-var !pommelib for pomme-3.
;-=============================================================================

   ;---------------------------------------------------------------------------
   ;   CHECK:
   ;---------------------------------------------------------------------------

   IF NOT istrue(model) THEN BEGIN 
      ;
      stop, 'insigificant model parameter structure'
      ;
   ENDIF

   ;---------------------------------------------------------------------------
   ;  CALL POMME INIT
   ;---------------------------------------------------------------------------

   status =  call_external(keyword_set(lib)?lib:!pommelib,'pomme_kill',model)
   model  =  !no

   return, status

END 
;==============================================================================
;  EOF pomme_kill.pro
;==============================================================================
