;===========================================================

   ;--------------------------------------------------
   ; CREATE TEST INPUT ARRAYS
   ;--------------------------------------------------

   vlen   = 1000L
   iarr   = lindgen(vlen)

   fday   = 300.1D  + iarr / vlen
   r      = 6371.2D + 10 * iarr * 50.D/vlen
   theta  = (3.0D   + 10 * iarr * 15.2D/vlen)
   phi    = 22.D    * iarr * 10 / vlen
   imf_by = -5.0D   + iarr * 10 / vlen
   e_st   = -10.D   * 10 * iarr / vlen
   i_st   = 0.3     * e_st * 10 * iarr / vlen

   ;--------------------------------------------------
   ; CALL
   ;--------------------------------------------------

   bench,'calc-2, len = '+q(vlen)

   b = pomme_calc(                     $
                   model,              $
                   vlen,               $
                   fday,               $
                   r,                  $
                   theta,              $
                   phi,                $
                   e_st,               $
                   i_st,               $
                   imf_by              )
   bench,/show
   help,/struct,b

END
;===========================================================
