%==============================================================================
%
%   testing: 'run1.m', output to stdout
%
%   2004-Nov-10. Martin Rother (rother@gfz-potsdam.de).
%   2006-Feb-02. for Pomme 3.0/3.1.
%==============================================================================

%%  CUSTOMIZE HERE: 

%%           where the parameter files are...

pomme_cf   = '../D/pomme-3.1.cof';
sm2geo_cf  = '../D/sm2geo_coeff';
gsm2geo_cf = '../D/gsm2geo_coeff';

%%           output format to stdout

format     = ['   Input: %d %8.3f %8.3f %8.3f %7.3f %6.2f %6.2f %4.1f\n\n',...
              'Internal: %9.3f %9.3f %9.3f %9.3f\n',                       ...
              'External: %9.3f %9.3f %9.3f\n'                                ];

%%  CALL INITIALISATION (LOAD CF AND PAR)

model      = pomme_init(pomme_cf, sm2geo_cf, gsm2geo_cf);

%% LOOP ON SOME DUMMY INPUT ON SINGLE CALCULATION CALLS

for i = 0:9

  fday    = 300.1 + i*33.07;
  r       = 6371.2 + i*50;
  theta   = (3.0 + i*15.2) * pi / 180.0; 
  phi     = 22*i  * pi / 180.0;          

  imf_by  = -5.0  + i;
  e_st    = -10.0 * i;
  i_st    = 0.3   * e_st;

  %% SINGLE CALCULATION, RETURNS:  bm_internal(X,Y,Z,F) and be_external(X,Y,Z)

  [bm, be]   = pomme_calc(model, fday, r, theta, phi, e_st, i_st, imf_by);

   %% OUTPUT TO STDOUT
   
  disp(sprintf(format,                                     ...
               i,                                          ...
               fday,                                       ...
               r,                                          ...
               theta * 180.0/pi,                           ...
               phi   * 180.0/pi,                           ...
               e_st, i_st, imf_by,                         ...
               bm(1),bm(2),bm(3),bm(4), be(1),be(2),be(3)  ...
               ));
  
end  

%==============================================================================